<?php
// Error Class - error_class.php

// Class - Error
class error {
var $default_log_name;
var $log;

// Log The Errors
function log($error) {
	$user_ip = $_SERVER['REMOTE_ADDR'];
	$current_date = date(get_config(date));
	
	// Determing if Logging Is Enabled
	if (get_config(log_errors) == 1) {
		// Use Default Log
		if (empty($this->log)) {
			$log = fopen($this->default_log_name,'a');
			fputs($log, '{'.$error.'} - IP: '.$user_ip.' | '.$current_date."\n");
			fclose($log);
		}
		// Use Custom Log
		else {
			$log = fopen($this->log,'a');
			fputs($log, '{'.$error.'} - IP: '.$user_ip.' | '.$current_date."\n");
			fclose($log);
		}
	}
}

// Report Errors
function report($error) {
	switch ($error) {
	case B_MISSING:  // Missing Block Called
		$message = '<b>Error:</b> Block Doesn\'t Exist';
	break;
	case T_MISSING:  // Missing Template Called
		$message = '<b>Error:</b> Template Doesn\'t Exist';
	break;
	case A_MISSING:  // Missing Article Called
		$message = '<b>Error:</b> Article Doesn\'t Exist';
	break;
	case V_FAILURE:  // Validation Blocked Input
		$message = '<b>Error:</b> Validation Block';
	break;
	case FILE_MISSING:  // Missing File Called
		$message = '<b>Error:</b> File is Missing';
	break;
	case UNREADABLE_FILE:  // Unreadable File Called
		$message = '<b>Error:</b> File is Unreadable';
	break;
	case UNWRITABLE_FILE:  // Unwritable File Called
		$message = '<b>Error:</b> File is Unwritable';
	break;
	case DIR_FILE: // Directory Called
		$message = '<b>Error:</b> File is a Directory';
	break;
	case LINK_FILE:  // Symlink Called
		$message = '<b>Error:</b> File is a Symlink';
	break;
	case NO_CSS_TEMPLATE: // Non-CSS Template Called
		$message = '<b>Error:</b> This Template Isn\'t CSS';
	break;
	case NO_JS_TEMPLATE: // Non-JavaScript Template Called
		$message = '<b>Error:</b> This Template Isn\'t JavaScript';
	break;
	case NO_RSS_TEMPLATE:  // None-RSS Template Called
		$message = '<b>Error:</b> This Template Isn\'t RSS';
	break;
	case FAILED_LOGIN:  // Admin Login Failed
		$message = '<b>Error:</b> Block Doesn\'t Exist';
	break;
	}
	$this->log($error);
	return $message;
}

function error($log = '') {
	global $default_path;
	// Choose Between a Custom or Default Log
	if (empty($log)) {
		$this->default_log_name = $default_path.'logs/errors.txt';
	}
	else {
		$this->log = $default_path.'logs/' . $log;
	}
}
}
?>