<?php

// Avoid remote file inclusion
if (isset($_GET['default_path'])) {
	unset($_GET['default_path']);
	$default_path = NULL;
}

// Classes - main_class.php
require_once $default_path.'format.php';
require_once $default_path.'classes/error_class.php';
require_once $default_path.'classes/validate_class.php';

// Class - Category
class Category {
var $cat_id;
var $cat_name;
var $parent_id;
var $cat_url;
var $cat_type;
var $items;
var $cat_describe;
var $sub_categories;
// Objects
var $cat_validator;
var $cat_error;

function category($id) {
	// Create Error & Validator Objects
	$this->cat_error = new error();
	$this->cat_validator = new validator();
	
	$cat_sql = mysql_query('SELECT * FROM categories WHERE id = \''.$id.'\'');
	// Set Initial Values
	while($cat = mysql_fetch_array($cat_sql)){
		$this->cat_id = $cat['id'];
		$this->cat_name = $this->cat_validator->killEntities($cat['cat_name']);
		$this->parent_id = $cat['parent_id'];
		$this->cat_url = $cat['cat_url'];
		$this->cat_type = $cat['cat_type'];
		$this->items = $cat['items'];
		$this->cat_describe = $cat['cat_describe'];
	}
	
	// Determine If There are Sub Categories
	$cat_sql = mysql_query('SELECT * FROM categories WHERE parent_id = \''.$this->cat_id.'\'');
	$this->sub_categories = mysql_num_rows($cat_sql);
}
}

// Class - Article
class Article {
var $article_body;
var $article_name;
var $article_author;
var $article_cat;
var $article_date;
var $article_id;
var $article_summary;
var $article_status;
var $page;
var $total_pages;
// Objects
var $article_error;
var $article_validator;

// Format Body and Summary
function format() {
	$this->article_summary = bbcode($this->article_summary);
	$this->article_body = bbcode($this->article_body);
	$this->article_body = eregi_replace('{','&#123;',$this->article_body); 
	$this->article_body = eregi_replace('}','&#125;',$this->article_body);
	$this->article_summary = eregi_replace('{','&#123;',$this->article_summary); 
	$this->article_summary = eregi_replace('}','&#125;',$this->article_summary);
	$this->article_body = $this->article_validator->killEntities($this->article_body);
	$this->article_summary = $this->article_validator->killEntities($this->article_summary);
}

// Split the Articles Into Multiple Pages
function page () {
	$page = $this->page-1;
	$text = $this->article_body;
	$sign = '[new_page]';  // Sign to Split Pages
	$textpage = explode($sign,$text);
	$this->total_pages = sizeof($textpage); 
	$this->article_body =  $textpage[$page];
	$this->article_body = trim($this->article_body);
}

// Display Pages
function display_pages($format, $show2 = 1) {
	$current_page = $this->page;
	$first_1 = explode('{current}',$format);
	$first_2 = explode('{/current}',$first_1[1]);
	$first = $first_2[0]; // Holds Format For Current Page
	$format = preg_replace('/\{current\}(.+?)\{\/current\}/ise', '', $format);
	
	if ($this->total_pages == 1 && $show2 == 0) {}
	else {
		for ($f = 1; $this->total_pages+1 != $f; $f++) {
			if (!empty($first) && $f == $current_page) {
				$page .= str_replace('{page_num}', $f, $first);
			}
			elseif (!empty($first) && $f != $current_page) {
				$page .= str_replace('{page_num}', $f, $format);
			}
			elseif (empty($first)) {
				$page .= str_replace('{page_num}', $f, $format);
			}
		}
	}
	return $page;
}

// Show Article With Status Private or Draft
function show() {
	if ($this->article_status == 'private' || $this->article_status == 'draft') {
		unset($this->article_summary);
		
		$article_sql = mysql_query('SELECT id, article_body, article_name, article_author, article_cat, article_date, article_summary, article_status, UNIX_TIMESTAMP(article_date) as article_date FROM articles WHERE id = \''.$this->article_id.'\'');
		while($article = mysql_fetch_array($article_sql)){
			$this->article_body = $article['article_body'];
			$this->article_name = $this->article_validator->killEntities($article['article_name']);
			$this->article_author = $this->article_validator->killEntities($article['article_author']);
			$this->article_cat = $article['article_cat'];
			$this->article_date = date(get_config(date), $article['article_date']);
			$this->article_summary = $article['article_summary'];
			$this->format();
		}
	}
}

function article($id, $page = 1) {
	$this->page = $page;  // Gather Page
	// Create Error & Validator Objects
	$this->article_error = new error();
	$this->article_validator = new validator();
	
	$article_sql = mysql_query('SELECT id, article_body, article_name, article_author, article_cat, article_date, article_summary, article_status, UNIX_TIMESTAMP(article_date) as article_date FROM articles WHERE id = \''.$id.'\'');
	while($article = mysql_fetch_array($article_sql)) {
		$this->article_status = $article['article_status'];
		$this->article_id = $article['id'];
		// If Published Set All Values
		if ($article['article_status'] == 'publish') {
			$this->article_body = $article['article_body'];
			$this->article_name = $this->article_validator->killEntities($article['article_name']);
			$this->article_author = $this->article_validator->killEntities($article['article_author']);
			$this->article_cat = $article['article_cat'];
			$this->article_date = date(get_config(date), $article['article_date']);
			$this->article_summary = $article['article_summary'];
			$this->page();  // Format Pages
			$this->format();  // Format Body and Summary
		}
		// Notify That This is a Draft Article
		elseif ($article['article_status'] == 'draft') {
			$this->article_body = '<b>Error:</b> This Article Hasn\'t Been Published';
			$this->article_summary = $this->article_body;
		}
		// Notify That This is a Private Article
		elseif ($article['article_status'] == 'private') {
			$this->article_body = '<b>Error:</b> This Article Is Private';
			$this->article_summary = $this->article_body;
		}
	}
	// Report Error Message If Article Doesn't Exist
	if (mysql_num_rows($article_sql) == 0) {$this->article_body = $article_error->report('A_MISSING'); }
	}
}

// Class - Template
class Template {
var $template_body;
var $template_type;
var $template_url;
var $template_name;
var $current_b;

function template($id,$current_b) {
	$t_sql = mysql_query('SELECT * FROM templates WHERE t_url = \''.$id.'\'');
	// Set Template Values
	while($template = mysql_fetch_array($t_sql)) {
		$this->template_body = $template['body'];
		$this->template_type = $template['t_type'];
		$this->template_url = $template['t_url'];
		$this->template_name = $template['t_name'];
	}
	// Report Error Message If Template Doesn't Exist
	if (mysql_num_rows($t_sql) == 0) { $template_error = new error(); $this->template_body = $template_error->report('T_MISSING'); }
	
	$this->current_b = $current_b;  // Current Block
	$this->template_body = format($this->template_body, $current_b);  // Run Body Through Formatting
	$this->template_body = current_format($this->template_body, $this->current_b); // Run Body For Current Block
	// Execute Operations Based On Template Type
	if ($this->template_type == 'bbcode') { $this->template_body = bbcode($this->template_body); }
	if ($this->template_type == 'javascript') { $this->template_body = '<script type="text/javascript">'.$this->template_body.'</script>'; }
	if ($this->template_type == 'css"') { $this->template_body ='<style type="text/css">'.$this->template_body.'</style>'; }
}
}

// Class - Block
class Block {
var $show_header;
var $block_name;
var $block_body;
var $current_b;
var $get;

// Format URL Variable
function replace_get($get) {
	if (!empty($get)) {
		$this->block_body = preg_replace('/\{get\}/ise', '$get', $this->block_body);
		$this->block_body = preg_replace('/\{if\: no-get\}(.+?)\{\/if\}/ise', '', $this->block_body);
	}
	// If the URL Variable Isn't There
	else {
		// Find {if} Command If There Isn't A URL Variable
		$get_1 = explode('{if: no-get}',$this->block_body);
		$get_2 = explode('{/if}',$get_1[1]);
		if (!empty($get_2[0])) {
		$this->block_body = $get_2[0];  // Set This Value To Body
		}
	}
	$this->block_body = format($this->block_body, $current_b);
	$this->block_body = current_format($this->block_body, $this->current_b);
}

function block($site_url, $current_b) {
	$block_error = new error(); // Create Error Class
	$block_sql = mysql_query('SELECT * FROM blocks WHERE block_url = \''.$site_url.'\'');
	// Set Block Values
	while($block = mysql_fetch_array($block_sql)) {
		$this->block_name = $block['block_name']; 
		$this->block_body = $block['body'];
		$this->show_header = $block['show_header'];
		$this->get = $block['get'];
	}
	// $this->block_body = preg_replace('#&#', "&amp;", $this->block_body);
	// Report Error Message If Block Doesn't Exist
	if (mysql_num_rows($block_sql) == 0) { $this->block_body = $block_error->report('B_MISSING'); }
	$this->current_b = $current_b;
	if (empty($this->get)) {
		$this->block_body = format($this->block_body, $current_b);
		$this->block_body = current_format($this->block_body, $this->current_b);
	}
}
}

// Class - Page Template: Header and Footer
class Page_Template {
var $template_header;
var $template_footer;
var $current_b;

function page_template($current_b) {
	// Get Default Header & Footer Blocks
	$header_block = new Block(get_config(default_header), $current_b);
	$footer_block = new Block(get_config(default_footer), $current_b);
	
	$this->template_header = $header_block->block_body;
	$this->template_footer = $footer_block->block_body;
}
}

?>