<?php

// Function - Format PHP
function formatPHP($str) {
	$str  = ($php_adjust && !strstr($str, '<?')) ? '<?php' . '\n' . $str . '\n' . '?>' : $str;
	
	$str = str_replace('\"','"',$str);
	$str = str_replace('\n','',$str);
	
	$str = str_replace('&lt;', '<', $str); 
	$str = str_replace('&gt;', '>', $str);
	
	$str = str_replace('<br />', '', $str);
	$str = str_replace('<br>', '', $str);
	$str = trim($str);
	
	$highlight = highlight_string($str, true);
	
	$highlight = str_replace('&lt;br /&gt;', '', $highlight);
	$highlight = str_replace('&lt;br&gt;', '', $highlight);
	
	$highlight = nl2br($highlight);
	
	$code_start_html = '<div class="quote"><div class="forum-header">PHP:</div><div class="forum-cell">'; 
	$code_end_html =  '</div></div>';
	
	$replacement = $code_start_html;
	$replacement .= $highlight; 
	$replacement .= $code_end_html;
	return $replacement;
}

// Function - Remove  Commands
function noCommands($text) {
	$text = preg_replace('/\{(.+?)\}/ise', '', $text);
	return $text;
}

// Function - Admin Login
function adminLogin($text) {
	$admin = $_SESSION['logged_in'];
	if (!empty($admin)) {
		return $text;
	}
}

// Function - Format List
function format_list($text, $type) {
	if ($type == 'ordered') { $value = '<ol>'; }
	else { $value = '<ul>'; }
		$text = preg_replace('/\[\*\](.*?)<br \/>/is', '<li>$1</li>', $text);
		$text = str_replace('<br />', '', $text);
		$value .= $text;
	if ($type == 'ordered') { $value .= '</ol>';}
	else {  $value .= '</ul>'; }
	return $value;
}

// Function - Replace Configuration Variables
function config($id) {
	$config_sql = mysql_query('SELECT * FROM configuration WHERE c_name = \''.$id.'\'');
	while($config = mysql_fetch_array($config_sql)){
		$value = $config['c_value'];
	}
	return $value;
}

// Function - Include Template
function template($id, $current_b) {
	$template = new Template($id,$current_b);
	return $template->template_body;
}

// Function - Include Block
function block($id, $current_b) {
	$block = new block($id,$current_b);
	return $block->block_body;
}

// Function - Include File
function import_file($id, $type) {
	$fp = fopen($id, 'r');
	$contents = fread($fp, filesize($id));
	if ($type == 'bbcode') { $contents = bbcode($contents); }
	fclose($fp);
	return $contents;
}

// Function - List All Of An Object
function full_list($id, $body, $order = 'id') {
	// List All Blocks
	if ($id == 'blocks') {
		$block_sql = mysql_query('SELECT * FROM blocks ORDER BY '.$order);
		while($block = mysql_fetch_array($block_sql)) {
			$original[0] = '/{block_id}/';
			$original[1] = '/{block_name}/';
			$original[2] = '/{block_url}/';
			$original[3] = '/{block_body}/';
			
			$replacement[0] = $block['id'];
			$replacement[1] = $block['block_name'];
			$replacement[2] = $block['block_url'];
			$replacement[3] = $block['body'];
			
			ksort($original);
			ksort($replacement);
			
			$result .= preg_replace($original, $replacement, $body);
		}
	}
	// List All Templates
	elseif ($id == 'templates') {
		$template_sql = mysql_query('SELECT * FROM templates ORDER BY '.$order);
		while($template = mysql_fetch_array($template_sql)) {
			$original[0] = '/{template_id}/';
			$original[1] = '/{template_name}/';
			$original[2] = '/{template_url}/';
			$original[3] = '/{template_type}/';
			$original[4] = '/{template_body}/';
			
			$replacement[0] = $template['id'];
			$replacement[1] = $template['t_name'];
			$replacement[2] = $template['t_url'];
			$replacement[3] = $template['t_type'];
			$replacement[4] = $template['body'];
			
			ksort($original);
			ksort($replacement);
			
			$result .= preg_replace($original, $replacement, $body);
		}
	}
	// List All Articles
	elseif ($id == 'articles') {
		$article_sql = mysql_query('SELECT id FROM articles WHERE article_status = \'publish\' ORDER BY '.$order);
		while($article = mysql_fetch_array($article_sql)) {
			$article = new Article($article['id']);
			
			$original[0] = '/{article_name}/';
			$original[1] = '/{article_author}/';
			$original[2] = '/{article_cat}/';
			$original[3] = '/{article_date}/';
			$original[4] = '/{article_body}/';
			$original[5] = '/{article_id}/';
			$original[6] = '/{article_summary}/';
			
			$replacement[0] = $article->article_name;
			$replacement[1] = $article->article_author;
			$replacement[2] = $article->article_cat;
			$replacement[3] = $article->article_date;
			$replacement[4] = $article->article_body;
			$replacement[5] = $article->article_id;
			$replacement[6] = $article->article_summary;
			
			ksort($original);
			ksort($replacement);
			
			$result .= preg_replace($original, $replacement, $body);
		}
	}
	// List All Categories
	elseif ($id == 'categories') {
		$cat_sql = mysql_query('SELECT * FROM categories ORDER BY '.$order);
		while($cat = mysql_fetch_array($cat_sql)) {
			$category = new Category($cat['id']);
				 
			$original[0] = '/{cat_id}/';
			$original[1] = '/{cat_name}/';
			$original[2] = '/{articles}/';
			$original[3] = '/{cat_describe}/';
			$original[4] = '/{cat_url}/';
			
			$replacement[0] = $category->id;
			$replacement[1] = $category->cat_name;
			$replacement[2] = $category->articles;
			$replacement[3] = $category->cat_describe;
			$replacement[4] = $category->cat_url;
			
			ksort($original);
			ksort($replacement);
			
			$result .= preg_replace($original, $replacement, $body);
		}
	}
	return $result;
}

// Function - Display Categories
function cat($body, $parent, $url) {
	// Select Sub Categories of Parent
	if (!empty($parent)) { $cat_sql = mysql_query('SELECT id FROM categories WHERE parent_id = \''.$parent.'\''); }
	// Select Single Category
	elseif (!empty($url)) { $cat_sql = mysql_query('SELECT id FROM categories WHERE cat_url = \''.$url.'\''); }
	// Select All Categories - No Sub Categories
	else { $cat_sql = mysql_query('SELECT id FROM categories WHERE parent_id = \'0\''); }
	while($cat = mysql_fetch_array($cat_sql)) {
		$category = new Category($cat['id']);
		$body_temp = $body;
		
		// Determine If Parent Categories
		$parent_sql = mysql_query('SELECT id FROM categories WHERE id = \''.$category->parent_id.'\'');
		$parent = mysql_num_rows($parent_sql);
		
		// If Parent Category Then Display {if} Command
		if ($parent == 1) {
			$parent_1 = explode('{if: parent-cat}',$body_temp);
			$parent_2 = explode('{/if}',$parent_1[1]);
			$parent_text = $parent_2[0]; // Holds Format For Parent Category
			
			while($parent = mysql_fetch_array($parent_sql)) {
				$parent_cat = new Category($parent['id']); // Create Category Object
			}
			
			$original[0] = '/{cat_id}/';
			$original[1] = '/{cat_name}/';
			$original[2] = '/{articles}/';
			$original[3] = '/{cat_describe}/';
			$original[4] = '/{cat_url}/';
			
			$replacement[0] = $parent_cat->id;
			$replacement[1] = $parent_cat->cat_name;
			$replacement[2] = $parent_cat->articles;
			$replacement[3] = $parent_cat->cat_describe;
			$replacement[4] = $parent_cat->cat_url;
			
			ksort($original);
			ksort($replacement);
			
			$result .= preg_replace($original, $replacement, $parent_text); 
		}
		// Remove {if} Command From Body Template
		$body_temp = preg_replace('/\{if\: parent-cat\}(.+?)\{\/if\}/is', '', $body_temp);
		
		// Gather Code for Sub Categories and Process It
		$body_temp = preg_replace('/\{sub_cat\}(.+?)\{\/sub_cat\}/ise', 'cat("$1",$cat[id],"")', $body_temp);
		
		// Text Displayed Only If Sub Categories
		if ($category->sub_categories == 0) {
			$body_temp = preg_replace('/\{if\: subcat\}(.+?)\{\/if\}/is', '', $body_temp);
		}
		else {
			$body_temp = preg_replace('/\{if\: subcat\}(.+?)\{\/if\}/is', '$1', $body_temp);
		}
		
		$original[0] = '/{cat_id}/';
		$original[1] = '/{cat_name}/';
		$original[2] = '/{articles}/';
		$original[3] = '/{cat_describe}/';
		$original[4] = '/{cat_url}/';
		
		$replacement[0] = $category->id;
		$replacement[1] = $category->cat_name;
		$replacement[2] = $category->articles;
		$replacement[3] = $category->cat_describe;
		$replacement[4] = $category->cat_url;
		
		ksort($original);
		ksort($replacement);
		
		$result .= preg_replace($original, $replacement, $body_temp);
	}
	return $result;
}

// Function - Display Articles
function article($cat, $num, $format, $id, $extra, $extra2) {
	if (!empty($extra2)) { $extra2 = 'ORDER BY '.$extra2; }
	
	// Displays Single Article
	if (!empty($id)) { global $page; $article_sql = mysql_query('SELECT id FROM articles WHERE id = \''.$id.'\''); }
	// Displays Latest from All Categories, Limited
	elseif (empty($cat)) { $article_sql = mysql_query('SELECT id FROM articles WHERE article_status = \'publish\' ORDER BY article_date DESC LIMIT 0, '.$num); }
	// Displays Latest in Category With Limit
	elseif (is_numeric($num) && !empty($cat)) {
		// Get Articles From Sub Categories
		if ($extra != 'nosub') {
			$cat_sql = mysql_query('SELECT id FROM categories WHERE cat_url = \''.$cat.'\'');
			while($cat1 = mysql_fetch_array($cat_sql)) {
				$cat2_sql = mysql_query('SELECT cat_url FROM categories WHERE parent_id = \''.$cat1['id'].'\'');
				while($cat2 = mysql_fetch_array($cat2_sql)) {
					$sub_cat .= 'OR article_cat = \''.$cat2['cat_url'].'\'';
				}
			}
		}
		$article_sql = mysql_query('SELECT id FROM articles WHERE (article_status = \'publish\') AND (article_cat = \''.$cat.'\' '.$sub_cat.') ORDER BY article_date DESC LIMIT 0, '.$num);
	}
	elseif (empty($num)) {
		// Get Articles From Sub Categories
		if ($extra != 'nosub') {
			$cat_sql = mysql_query('SELECT id FROM categories WHERE cat_url = \''.$cat.'\'');
			while($cat1 = mysql_fetch_array($cat_sql)) {
				$cat2_sql = mysql_query('SELECT cat_url FROM categories WHERE parent_id = \''.$cat1['id'].'\'');
				while($cat2 = mysql_fetch_array($cat2_sql)) {
					$sub_cat .= 'OR article_cat = \''.$cat2['cat_url'].'\'';
				}
			}
		}
		$article_sql = mysql_query('SELECT id FROM articles WHERE (article_status = \'publish\') AND (article_cat = \''.$cat.'\' '.$sub_cat.') '.$extra2);
	}
	
	// Loop Through Final SQL Query
	while($article = mysql_fetch_array($article_sql)) {
		if ($page) {
			$article = new Article($article['id'], $page);
		}
		else {
			$article = new Article($article['id']);
		}
		
		$body_temp = $format;
		// Determine How Pages Will Be Displayed
		$body_temp = preg_replace('/\{display_pages\: only-multiple\}(.+?)\{\/display\}/ise', '$article->display_pages("$1","0")', $body_temp);
		$body_temp = preg_replace('/\{display_pages\}(.+?)\{\/display\}/ise', '$article->display_pages("$1")', $body_temp);
		
		// Determind How Pages Will Be Displayed If Only One Page
		if ($article->total_pages == 1) { $body_temp = preg_replace('/\{if\: pages\}(.+?)\{\/if\}/ise', '', $body_temp); }
		else { $body_temp = preg_replace('/\{if\: pages\}(.+?)\{\/if\}/is', '$1', $body_temp); }
		
		$original[0] = '/{article_name}/';
		$original[1] = '/{article_author}/';
		$original[2] = '/{article_cat}/';
		$original[3] = '/{article_date}/';
		$original[4] = '/{article_body}/';
		$original[5] = '/{article_id}/';
		$original[6] = '/{article_summary}/';

		$replacement[0] = $article->article_name;
		$replacement[1] = $article->article_author;
		$replacement[2] = $article->article_cat;
		$replacement[3] = $article->article_date;
		$replacement[4] = $article->article_body;
		$replacement[5] = $article->article_id;
		$replacement[6] = $article->article_summary;
		
		ksort($original);
		ksort($replacement);
		
		$result .= preg_replace($original, $replacement, $body_temp);
	}
	return $result;
}

// Function - Format Code And Call Functions
function format($text, $current_b) {
	global $page;
	$text = stripslashes($text);
	
	// Import Config, Template, Blocks, and Files
	$text = preg_replace('/\{config\: (.+?)\}/ise', 'config("$1")', $text); // Import Config
	$text = preg_replace('/\{template\: (.+?)\}/ise', 'template("$1","$current_b")', $text);  // Import Template
	$text = preg_replace('/\{block\: (.+?)\}/ise', 'block("$1","$current_b")', $text); // Import Block
	$text = preg_replace('/\{file\: (.+?) \| (.+?)\}/ise', 'import_file("$1","$2")', $text); // Import File & Format As BBCode
	$text = preg_replace('/\{file\: (.+?)\}/ise', 'import_file("$1","")', $text); // Import File
	
	// Conditional
	$text = preg_replace('/\{if\: admin-login\}(.+?)\{\/if\}/ise', 'adminLogin("$1")', $text); // Display a Single Category
	
	// Static Variables
	$text = preg_replace('/\{date\: (.+?)\}/ise', 'date("$1")', $text);  // Custom Formatted Date
	$text = preg_replace('/\{date\}/ise', 'date(get_config("date"))', $text);  // Default Date
	$text = preg_replace('/\{page\}/ise', $page, $text); // Page
	
	// List All of An Object
	$text = preg_replace('/\{list\: (.+?) \| (.+?)\}(.+?)\{\/list\}/ise', 'full_list("$1","$3","$2")', $text); // List All of an Object and Specified Order
	$text = preg_replace('/\{list\: (.+?)\}(.+?)\{\/list\}/ise', 'full_list("$1","$2")', $text); // List All of an Object
	
	// Cateogry
	$text = preg_replace('/\{category\}(.+?)\{\/category\}/ise', 'cat("$1","","")', $text); // Display All Categories
	$text = preg_replace('/\{category\: (.+?)\}(.+?)\{\/category\}/ise', 'cat("$2","","$1")', $text); // Display a Single Category
	
	// Articles
	$text = preg_replace('/\{display_latest\: (.+?) \| (.+?) \| nosub\}(.+?)\{\/display\}/ise', 'article("$1","$2","$3","","nosub","")', $text); // Displays Latest in Category With Limit - No Sub Categories
	$text = preg_replace('/\{display_latest\: (.+?) \| (.+?)\}(.+?)\{\/display\}/ise', 'article("$1","$2","$3","","","")', $text);  // Displays Latest in Category With Limit
	$text = preg_replace('/\{display_latest\: (.+?)\}(.+?)\{\/display\}/ise', 'article("","$1","$2","","","")', $text); // Displays Latest from All Categories With Limit
	$text = preg_replace('/\{article\: (.+?) \| (.+?)\}(.+?)\{\/article\}/ise', 'article("","","$3","$1","$2","")', $text); // Display Single Article & Page
	$text = preg_replace('/\{article\: (.+?)\}(.+?)\{\/article\}/ise', 'article("","","$2","$1","","")', $text); // Display Single Article
	$text = preg_replace('/\{display_cat\: (.+?) \| nosub \| (.+?)\}(.+?)\{\/display\}/ise', 'article("$1","","$3","","nosub","$2")', $text); // Display Cateory, No Sub Cateogries, Set Order
	$text = preg_replace('/\{display_cat\: (.+?) \| nosub\}(.+?)\{\/display\}/ise', 'article("$1","","$2","","nosub","")', $text); // Display Category, No Sub Categories
	$text = preg_replace('/\{display_cat\: (.+?) \| (.+?)\}(.+?)\{\/display\}/ise', 'article("$1","","$3","","","$2")', $text); // Displays All of One Category, Set Limit
	$text = preg_replace('/\{display_cat\: (.+?)\}(.+?)\{\/display\}/ise', 'article("$1","","$2","","","")', $text); // Displays All of One Category
	
	// Extra Formatting
	$text = stripslashes($text);
	$text = str_replace("\\\\\"", "\"", $text);
	$text = str_replace("\\\"", "\"", $text);
	return $text;
}

// Function - Current Block
function current_format($text, $current_b) {
	$text = preg_replace('/\{current_block}/ise', '$current_b', $text);
	return $text;
}

// Function - BBCode
function bbcode($text) {
	// Eliminate HTML and Format Line Breaks
	$text = eregi_replace('<','&lt;',$text); 
	$text = eregi_replace('>','&gt;',$text);
	$text = nl2br($text);
	
	// BBCode
	$original[0] = '/\[b\](.*?)\[\/b\]/';
	$original[1] = '/\[i\](.*?)\[\/i\]/';
	$original[2] = '/\[u\](.*?)\[\/u\]/';
	$original[3] = '/\[url=external=(.*?)\](.*?)\[\/url\]/';
	$original[4] = '/\[url=external\](.*?)\[\/url\]/';
	$original[5] = '/\[img\](.*?)\[\/img\]/';
	$original[6] = '/\[img=(.*?)\](.*?)\[\/img\]/';
	$original[7] = '#\[email\]([a-z0-9&\-_.]+?@[\w\-]+\.([\w\-\.]+\.)?[\w]+)\[/email\]#si';
	$original[8] = '/\[email=([a-z0-9&\-_.]+?@[\w\-]+\.([\w\-\.]+\.)?[\w]+)\](.*?)\[\/email\]/';
	$original[9] = '/\[q](.*?)\[\/q\]/';
	$original[10] = '/\[quote](.*?)\[\/quote\]/';
	$original[11] = '/\[q=(.*?)\](.*?)\[\/q\]/';
	$original[12] = '/\[quote=(.*?)\](.*?)\[\/quote\]/';
	$original[13] = '/\[color=(.*?)\](.*?)\[\/color\]/';
	$original[14] = '#\[url=((www|ftp)\.[^ \"\n\r\t<]*?)\](.*?)\[/url\]#is';
	$original[15] = '/\[url=(.*?)\](.*?)\[\/url\]/';
	$original[16] = '#\[url\]((www|ftp)\.[^ \"\n\r\t<]*?)\[/url\]#is';
	$original[17] = '/\[url\](.*?)\[\/url\]/';
	$original[18] = '/\[code](.*?)\[\/code\]/';
	$original[19] = '/\[code=(.*?)](.*?)\[\/code\]/';
	
	$replacement[0] = '<b>$1</b>';
	$replacement[1] = '<i>$1</i>';
	$replacement[2] = '<u>$1</u>';
	$replacement[3] = '<a href="$1" target="_blank">$2</a>';
	$replacement[4] = '<a href="$1" target="_blank">$1</a>';
	$replacement[5] = '<img src="$1" border="0" />';
	$replacement[6] = '<img src="$1" alt="$2" border="0" />';
	$replacement[7] = '<a href="mailto:$1">$1</a>';
	$replacement[8] = '<a href="mailto:$1">$3</a>';
	$replacement[9] = '<div class="quote"><div class="forum-header">Quote:</div><div class="forum-cell">$1</div></div>';
	$replacement[10] = '<div class="quote"><div class="forum-header">Quote:</div><div class="forum-cell">$1</div></div>';
	$replacement[11] = '<div class="quote"><div class="forum-header">Quote ($1):</div><div class="forum-cell">$2</div></div>';
	$replacement[12] = '<div class="quote"><div class="forum-header">Quote ($1):</div><div class="forum-cell">$2</div></div>';
	$replacement[13] = '<font color="$1">$2</font>';
	$replacement[14] = '<a href="http://$1">$3</a>';
	$replacement[15] = '<a href="$1">$2</a>';
	$replacement[16] = '<a href="http://$1">$1</a>';
	$replacement[17] = '<a href="$1">$1</a>';
	$replacement[18] = '<div class="quote"><div class="forum-header">Code:</div><div class="forum-cell">$1</div></div>';
	$replacement[19] = '<div class="quote"><div class="forum-header">Code ($1):</div><div class="forum-cell">$2</div></div>';
	
	// Smilies  
	$smilie[0] = '/\:\)/';
	$smilie[1] = '/\:D/';
	$smilie[2] = '/\:\(/';
	$smilie[3] = '/\:\|/';
	$smilie[4] = '/\:o/';
	$smilie[5] = '/\:0/';
	$smilie[6] = '/\:O/';
	$smilie[7] = '/\:S/';
	$smilie[8] = '/\:s/';
	$smilie[9] = '/\:P/';
	$smilie[10] = '/\:p/';
	$smilie[11] = '/\;\)/';
	$smilie[12] = '/\:\'\(/';
	$smilie[13] = '/\:X/';
	$smilie[14] = '/\:x/';
	$smilie[15] = '/8\)/';
	$smilie[16] = '/\:\*/';
	$smilie[17] = '/\;p/';
	$smilie[18] = '/\;P/';
	
	$image[0] = '<img src="/smilies/smile.gif" alt="smile" />';
	$image[1] = '<img src="/smilies/bigsmile.gif" alt="big grin" />';
	$image[2] = '<img src="/smilies/frown.gif" alt="frown" />';
	$image[3] = '<img src="/smilies/blank.gif" alt="huh?" />';
	$image[4] = '<img src="/smilies/shocked.gif" alt="shocked" />';
	$image[5] = '<img src="/smilies/shocked.gif" alt="shocked" />';
	$image[6] = '<img src="/smilies/shocked.gif" alt="shocked" />';
	$image[7] = '<img src="/smilies/sick.gif" alt="sick" />';
	$image[8] = '<img src="/smilies/sick.gif" alt="sick" />';
	$image[9] = '<img src="/smilies/tongue.gif" alt="razz" />';
	$image[10] = '<img src="/smilies/tongue.gif" alt="razz" />';
	$image[11] = '<img src="/smilies/wink.gif" alt="wink" />';
	$image[12] = '<img src="/smilies/cry.gif" alt="cry" />';
	$image[13] = '<img src="/smilies/muted.gif" alt="muted" />';
	$image[14] = '<img src="/smilies/muted.gif" alt="muted" />';
	$image[15] = '<img src="/smilies/cool.gif" alt="cool" />';
	$image[16] = '<img src="/smilies/kiss.gif" alt="kiss" />';
	$image[17] = '<img src="/smilies/secret.gif" alt="secret" />';
	$image[18] = '<img src="/smilies/secret.gif" alt="secret" />';
	
	// Sort All Arrays
	ksort($original);
	ksort($replacement);
	ksort($smilie);
	ksort($image);
	
	$text = preg_replace($original, $replacement, $text);
	$text = preg_replace($smilie, $image, $text);
	// Replace Smilies Without A Sybmol
	$text = preg_replace('/\[:(.*?):]/is', '<img src=\'/smilies/$1.gif\' alt=\'$1\' />', $text);
	//  Format Order & Unordered List
	$text = preg_replace('/\[ul\](.*?)\[\/ul\]/ise', 'format_list("$1","")', $text);
	$text = preg_replace('/\[ol\](.*?)\[\/ol\]/ise', 'format_list("$1","ordered")', $text);
	// Replace Smilies Without A Sybmol
	$text = preg_replace('/\[p\](.*?)\[\/p\]/ise', 'formatPHP("$1")', $text);
	$text = preg_replace('/\[php\](.*?)\[\/php\]/ise', 'formatPHP("$1")', $text);
	// Auto-Format URLs and Email Addresses
	$text = preg_replace("#(^|[\n ])([\w]+?://[^ \"\n\r\t<]*)#is", "\\1<a href=\"\\2\" target=\"_blank\">\\2</a>", $text);
	$text = preg_replace("#(^|[\n ])((www|ftp)\.[^ \"\t\n\r<]*)#is", "\\1<a href=\"http://\\2\" target=\"_blank\">\\2</a>", $text);
	$text = preg_replace("#(^|[\n ])([a-z0-9&\-_.]+?)@([\w\-]+\.([\w\-\.]+\.)*[\w]+)#i", "\\1<a href=\"mailto:\\2@\\3\">\\2@\\3</a>", $text);
	
	return $text;
}

?>